﻿/*
Название: SelectAndPlaceImage.jsx
Приложение для использования: Adobe InDesign CS3, CS4, CS5, CS6
Версия: 1.0
Язык реализации (Среда): JavaScript (ExtendScript Toolkit 2)
Операционные системы (Платформы): PC, Macintosh (Windows, Mac OS)
Условия распространения: Бесплатно; На Ваш риск
Назначение: Помещает изображение в выделенные графические фреймы. 
Возможно помещение изображения в несколько выделенных фреймов.
Техническая поддержка: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
===================================================
Name: SelectAndPlaceImage.jsx
Application to use with: Adobe InDesign CS3, CS4, CS5, CS6
Version: 1.0
Program language (Environment): JavaScript (ExtendScript Toolkit 2)
Operating systems (Platforms): PC, Macintosh (Windows, Mac OS)
Distribution conditions: Freeware; At your own risk
Functions: Places image into selected graphic frames.
Placement into multiple selection is possible.
Technical support: Sergey-Anosov@yandex.ru
https://sites.google.com/site/dtpscripting
*/
//
// ***** ОСНОВНОЙ МОДУЛЬ
//
// описание глобальных перемкнных
var TITLE = "SelectAndPlaceImage v.1.0";
// активный документ
var AD; 
// имя активного документа
var D_NAME; 
 // ссылка на активный разворот	
var AS;	
// начальное окно (для восстановления)
var BEGIN_WINDOW; 
// режим помещения изображений
var AUTO = 0; 
var AUTO_TEXT = "";
// путь файла с изображением
var NEW_FILE_PATH = "";
// имя файла с изображением
var NEW_FILE_NAME = ""; 
// файл с изображением
var NEW_FILE; 
// команда на продолжение операции
var PLACE_CONTINUE = true; 
// число пропущенных фреймов
var N_SKIP = 0; 
// число фреймов, в которые помещено изображение
var N_PLACED = 0;  
// число пропущенных внедренных изображений
var N_EMBEDDED = 0;
// отображать границы фреймов или рисунков
var SHOW_PLACEMENT_OPTIONS; 
var SHOW_PLACEMENT_OPTIONS_TEXT = "";
// возможность отобразить изображение
var CAN_SHOW = false; 
 // файловая система
var WFS = false;
// Количество ошибок
var N_ERR = 0; 
// выход из диалога замены
var QUIT_BY_USER = false;
// опции фиттинга
var FIT;
var FIT_TEXT ="";
// центрировать изображение после помещения
var CENTER;
var CENTER_TEXT = "";
// выход без выполнения опреации
var NO_OPERATION = true;
// массив фреймов в выделении
var FRAMES_IN_SEL = new Array();
// массив выделенных объектов
var the_sel = new Array();
// число фреймов
var N_F = 0;
//
// начало выполнения
main();
//
// основной модуль
function main()
{
	FIND_FRAMES_SEL();
	if(!DIALOG_SHOW()) exit();
	READ_NEW_FILE();
	if( !PLACE_CONTINUE ) exit();
	OPERATION();
};// end main
//
// ***** ПОДПРОГРАММА ВВОДА ИМЕНИ ФАЙЛА
function READ_NEW_FILE() 
{
	PLACE_CONTINUE = true;
	var SD = "Choose file to place";
	do 
	{
		NEW_FILE = File.openDialog(SD);
		if( NEW_FILE == null ) 
		{
			if ( confirm("File to place is not chosen! Quit?") == true ) 
			{
				PLACE_CONTINUE = false;
				break;
			};// if
			continue;
		};// if
		//
		NEW_FILE_PATH = FIX_PATH( unescape( NEW_FILE.fsName ) ); 
		NEW_FILE_NAME = unescape( GET_NAME_FROM_PATH( NEW_FILE_PATH  ) );
		//проверяем тип выбранного файла по расширению
		if( ! EXT_OK( NEW_FILE_NAME ) )
		{
			var CONF_STR_EXT = 
			"Likely type of the chosen file is not image!\nContinue?";
			if( !confirm (CONF_STR_EXT) ) the_exit("");
		};// if
		var CONF_STR =  
		TITLE + "\n"+
		"Options confirmation\n\n"+
		"Document: "+D_NAME+"\n\n"+
		"File to place name: "+ NEW_FILE_NAME+"\n"+
		NEW_FILE_PATH+"\n\n"+
		"Graphic frames in the selection: "+N_F+"\n"+
		"Placement mode: "+AUTO_TEXT+"\n"+
		"Show placement options: "+ SHOW_PLACEMENT_OPTIONS_TEXT+"\n"+
		"Fitting option: "+FIT_TEXT+"\n"+
		"Center images after placement: " + CENTER_TEXT+"\n\n"+
		"Place?";
		if (confirm(CONF_STR) == false) 
		{
			PLACE_CONTINUE = false; 
			return;
		};// if
		return;
	} 
	while (true);
	return;
};// end READ_NEW_FILE
//
// ***** ПОДПРОГРАММА ОТОБРАЖЕНИЯ начального ДИАЛОГА
function DIALOG_SHOW() 
{
	dlg = new Window('dialog');
	dlg.text = TITLE;
	// основная панель
	var mp = dlg.add('panel');
	mp.alignChildren = 'left';
	//
	// подпрограмма создания статического текста
	function TEXT( txt )
	{
		var t = mp.add('statictext');
		t.text = txt;
		return t;
	};// end TEXT
	//
	// подпрограмма создания чекбокса
	function CB( ini, txt )
	{
		var c = mp.add('checkbox');
		c.text = txt;
		c.value = ini;
		return c;
	};// end CB
	//
	// подпрограмма создания дропдауна с текстом
	function DDT( txt_len, txt, arr, ini )
	{
		var g = mp.add('group');
		var t = g.add('statictext');
		t.text = txt;
		var sh = 0; if( WFS ) sh = 1;
		t.characters = txt_len + sh;
		var d = g.add('dropdownlist');
		for( var i=0; i<arr.length; i++ ) d.add('item', arr[i] );
		d.selection = ini;
		d.maximumSize.width = 102;
		return d;
	};// end DDT
	//
	// выводим название документа
	TEXT( "Document: "+D_NAME );
	// выводим количество фреймов в выделении
	TEXT( "Graphic frames in the selection: "+N_F);
	//
	// выбор режима выполнения
	AUTO = DDT(5,"Mode: ", ["Step-by-step", "Auto"], 1 );
	//
	// показывать ли опции помещения
	SHOW_PLACEMENT_OPTIONS = CB( true, "Show placement options" );
	AUTO.onChange = function()
	{
		if( AUTO.selection.index == 1 ) DROP_ACTIVE_DEACTIVE( SHOW_PLACEMENT_OPTIONS, false );
		if( AUTO.selection.index == 0 ) DROP_ACTIVE_DEACTIVE( SHOW_PLACEMENT_OPTIONS, true );
	};
	// 
	// дополнительные настройки фиттинга
	//                                                               0                                         1                                                  2
	FIT = DDT(5, "Fitting: ", ["Use Prefences settings", "Fit content to frame", "Fit content to frame proportionally", 
	//          3                                               4                                             5 
	"Fit frame to content", "Fill frame proportionally", "Set content scaling to 100%"], 5 );
	//
	// центрировать ли новые изображения
	CENTER = CB( true, "Center images after placement" );
	//
	// подпрограмма деактивации / активации списка
	function DROP_ACTIVE_DEACTIVE( the_drop, act ) 
	{
		var NA;
		if( !act ) 
		{
			if( !the_drop.enabled ) return;
			NA = the_drop.add('item', "N/A");
			NA.selected = true;
			the_drop.enabled = false;
		} 
		else 
		{
			try 
			{
				if( the_drop.enabled ) return;
				the_drop.remove(  the_drop.items[the_drop.items.length-1]  );
				the_drop.items[0].selected = true;
				the_drop.enabled = true;
			} catch ( error ) {};
		};// if
		return;
	};// end DROP_ACTIVE_DEACTIVE
	//
	AUTO.minimumSize.width = SHOW_PLACEMENT_OPTIONS.minimumSize.width = 
	AUTO.maximumSize.width = SHOW_PLACEMENT_OPTIONS.maximumSize.width = 
	FIT.maximumSize.width = 175;
	// создание панели кнопок (кнопка ОК, кнопка Cancel)
	var okPanel = dlg.add('group');
	okPanel.orientation = 'row';
	var okBtn = okPanel.add('button', undefined, 'Choose file to place');// кнопка ОК
	dlg.defaultElement = okBtn;
	var cancelBtn = okPanel.add('button', undefined, 'Cancel');// кнопка Cancel
	// собственно показываем окно диалога
	var DIALOG_BUTTON = dlg.show();
	// если нажали ОК
	if (DIALOG_BUTTON == 1) 
	{
		SHOW_PLACEMENT_OPTIONS = SHOW_PLACEMENT_OPTIONS.value;
		if( SHOW_PLACEMENT_OPTIONS ) SHOW_PLACEMENT_OPTIONS_TEXT = "Yes"
		else  SHOW_PLACEMENT_OPTIONS_TEXT = "No";
		AUTO_TEXT = AUTO.selection.text;
		AUTO = AUTO.selection.index;
		if( AUTO == 0 ) AUTO = false
		else AUTO = true; 
		FIT_TEXT = FIT.selection.text;
		FIT = FIT.selection.index;
		CENTER = CENTER.value;
		if( CENTER ) CENTER_TEXT = "Yes"
		else CENTER_TEXT = "No";
		return true;
	};// if OK
	// если нажали Cancel
	if (DIALOG_BUTTON == 2) return false;
};// end DIALOG_SHOW
//
//
// ***** ПОДПРОГРАММА ИСПРАВЛЕНИЯ ПУТИ
// ***** убираем двоеточия для МАКа
function FIX_PATH(p) 
{
	if( WFS ) return p;
	fp = "";
	for( var i=0; i < p.length; i++ )
	{
		var p_i = p[i];
		if( p_i == ":" )
		{
			fp = fp + "/";
			continue;
		};// if
		fp = fp + p_i;
	};// for
	return fp;
};// end FIX_PATH
//
// ******** ПОДПРОГРАММА снятия выделения
function DESELECT_ALL() 
{
	try
	{
		app.select( null );
	} catch ( error ) {};
	return;
};// end DESELECT_ALL
//
// ******** ПОДПРОГРАММА ОТОБРАЖЕНИЯ АКТИВНОГО ОБЪЕКТА
function zoomObject( the_obj ) 
{
	CAN_SHOW = true;
	try 
	{
		var obj_bounds = the_obj.geometricBounds;
		var obj_height = obj_bounds[2] - obj_bounds[0];
		var obj_width = obj_bounds[3] - obj_bounds[1];
		var AW = app.activeWindow;
		var page_bounds = AW.activePage.bounds;
		var page_height = page_bounds[2] - page_bounds[0];
		var page_width = page_bounds[3] - page_bounds[1];
		var h_ratio  = page_height / obj_height;
		var w_ratio = page_width / obj_width;
		var zoomRatio = Math.min( h_ratio, w_ratio );
		app.select( the_obj, SelectionOptions.replaceWith );
		AW.zoom( ZoomOptions.fitPage );
		AW.zoomPercentage = AW.zoomPercentage * zoomRatio;
	}
	catch ( error ) 
	{
		CAN_SHOW = false;
	};// try-catch
	return;
};// end zoomObject
//
// ******** ПОДПРОГРАММА ОТОБРАЖЕНИЯ ДИАЛОГА ДЛЯ АКТИВНОГО ОБЪЕКТА
function DIAL_FOUND( obj_found, i ) 
{
	zoomObject( obj_found );
	with(myDialog2 = app.dialogs.add({name:TITLE, canCancel:false}))
	{
		with(dialogColumns.add())
		{
			dialogRows.add().staticTexts.add({staticLabel:"Document: "+D_NAME});
			dialogRows.add().staticTexts.add({staticLabel:"File name :  "+NEW_FILE_NAME});
			dialogRows.add().staticTexts.add({staticLabel:"Frame: "+i});
			if( !CAN_SHOW )
			{ 
				dialogRows.add().staticTexts.add({staticLabel:"Can not show!"});
				dialogRows.add().staticTexts.add({staticLabel:" "});
			};// if
			with( WHAT2 = radiobuttonGroups.add())
			{
				radiobuttonControls.add({staticLabel:"Place", checkedState:true});
				radiobuttonControls.add({staticLabel:"Skip"});
				radiobuttonControls.add({staticLabel:"Quit operation"});
			};// with
		};// with
		myDialog2.show();
	};// with
	WHAT2 = WHAT2.selectedButton;
	myDialog2.destroy();
	if(WHAT2 == 0) 
	{
		ASSIGN = true;
		return;
	};// if
	if(WHAT2 == 1) 
	{
		N_SKIP++;
		ASSIGN = false;
		return;
	};// if
	if(WHAT2 == 2) 
	{
		QUIT_BY_USER = true;
		the_exit();
	};// if
	return;
};// end DIAL_FOUND
//
// ******** ПОДПРОГРАММА размещения файла в выделенных фреймах
function OPERATION() 
{
	NO_OPERATION = false;
	// помещаемый файл ПДФ
	var PLACE_PDF = false;
	// помещыемый файл документ ИнДизайна
	var PLACE_PAGE = false;
	// номер помещаемой страницы для многостраничного документа
	var PN;
	// graphicLayerOptions для помещаемого изображения
	var GL = new Array();
	// количество слоев
	var GL_LEN = 0;
	//
	// подпрограмма получения индекса изображения во фрейме
	function GET_IMAGE_INDEX( F )
	{
		var the_file = new File( NEW_FILE_PATH );
		for( var i=0; i < F.allGraphics.length; i++ )
		{
			var g_i = F.allGraphics[i];
			var file_i = new File( g_i.itemLink.filePath );
			if( the_file.filePath == file_i.filePath ) return i;
		};// for i
	};// end GET_IMAGE_INDEX
	//
	// цикл по выделенным фреймам
	for( var i = 0; i < N_F; i++)
	{
		// текущий фрейм
		var F_i = FRAMES_IN_SEL[i];
		// ID текущего фрейма
		var F_i_ID = F_i.id;
		// 
		if( AUTO )
		{
			if( i == 0 && SHOW_PLACEMENT_OPTIONS ) SHOW_PLACEMENT_OPTIONS = true
			else SHOW_PLACEMENT_OPTIONS = false;
		};// if
		try
		{
			// если автоматическое размещение
			if( AUTO )
			{
				try
				{
					// присваиваем номер страницы для помещенного изображения
					// ( для многостраничных файлов )
					if( i != 0 )
					{
						// для PDF
						if( PLACE_PDF ) app.pdfPlacePreferences.pageNumber = PN;
						// для помещенных страниц InDesign
						if( PLACE_PAGE ) app.importedPageAttributes.pageNumber = PN;
					};// if
					// помещаем
					F_i.place( NEW_FILE, SHOW_PLACEMENT_OPTIONS );
					// переопределяем фрейм
					F_i = AD.pageItems.itemByID( F_i_ID );
					// получаем индекс во фрейме
					var G_IND = GET_IMAGE_INDEX( F_i );
					// помещенное изображение
					var G = F_i.allGraphics[ G_IND ];
					if( i == 0 )
					{
						// проверяем видимость слоев если они есть
						// запоминаем видимость слоев для первого фрейма
						if( G.hasOwnProperty("graphicLayerOptions") )
						{
							GL_LEN = G.graphicLayerOptions.graphicLayers.length;
							for( var j = 0; j < GL_LEN; j++ )
							{
								GL[j] = G.graphicLayerOptions.graphicLayers[j].currentVisibility;
							};// for j
						};// if
						// проверяем на первом фрейме какой тип файлов помещаем
						// если PDF
						if( G.constructor.name == "PDF" ) 
						{
							PLACE_PDF = true;
						};// if
						// если страница InDesign
						if( G.constructor.name == "ImportedPage" ) 
						{
							PLACE_PAGE = true;
						};// if
						// если PDF или страница InDesign 
						if( PLACE_PDF || PLACE_PAGE )
						{
							// определяем номер помещенной страницы
							PN = G.pdfAttributes.pageNumber;
						};// if
					};// if
					// присваиваем видимость слоев для последующих фреймов
					if( i != 0 && G.hasOwnProperty("graphicLayerOptions") )
					{
						for( var j = 0; j < GL_LEN; j++ )
						{
							G = F_i.allGraphics[G_IND];
							var LAYERS = G.graphicLayerOptions.graphicLayers;
							if( LAYERS[j].currentVisibility != GL[j] ) LAYERS[j].currentVisibility = GL[j]
						};// for j
					};// if
					N_PLACED++;
				}
				catch ( error )
				{
					// если ошибка - считаем что в диалоге импорта нажато Cancel
					if( SHOW_PLACEMENT_OPTIONS ) { N_SKIP++; QUIT_BY_USER = true }
					else N_ERR++;
					the_exit();
				};// try-catch
			}
			// если пошаговое размещение
			else
			{
				DIAL_FOUND(F_i, i+1);
				if( ASSIGN ) 
				{
					try
					{
						F_i.place( NEW_FILE, SHOW_PLACEMENT_OPTIONS );
						N_PLACED++;
					}
					catch ( error )
					{
						// если ошибка - считаем что в диалоге импорта нажато Cancel
						if( SHOW_PLACEMENT_OPTIONS ) N_SKIP++
						else N_ERR++;
						continue;
					};// try-catch
				};// if
			};// if-else
		}
		catch ( error )
		{
			continue;
		};// try-catch
		if( FIT != 0 || CENTER ) FITTING( F_i );
	};// for
	the_exit();
};// end OPERATION
//
// подпрограмма применения настроек фоттинга к фрейму
// и/или изображению
function FITTING( F )
{
	try
	{
		if( FIT == 1 )  F.fit( FitOptions.CONTENT_TO_FRAME );
		if( FIT == 2 )  F.fit( FitOptions.PROPORTIONALLY );
		if( FIT == 3 )  F.fit( FitOptions.FRAME_TO_CONTENT );
		if( FIT == 4 )  F.fit( FitOptions.FILL_PROPORTIONALLY );
		if( FIT == 5 ) 
		{
			var G = F.allGraphics[0];
			G.absoluteVerticalScale = 100.;
			G.absoluteHorizontalScale = 100.;
		};// if
		if( CENTER  )  F.fit( FitOptions.CENTER_CONTENT );
	} catch ( error ) {};// try-catch
	return;
};// end  FITTING
//
// ******** ПОДПРОГРАММА вывода результатов выполнения операции
function REPORT()
{
	if( NO_OPERATION ) return;
	var S_SKIP ="";  if ( N_SKIP > 0 ) S_SKIP = "Skipped by user: "+N_SKIP+"\n";
	var S_ERR = ""; if ( N_ERR > 0 ) S_ERR = "Relink errors: "+N_ERR+"\n";
	var S_QBU =""; if ( QUIT_BY_USER ) S_QBU = "\nOperation was interrupted by user\n";
	alert
	(
		TITLE + "\n"+
		"Report\n\n"+
		"Document: "+D_NAME+ "\n\n"+
		"File name:  "+NEW_FILE_NAME+ "\n"+
		NEW_FILE_PATH+"\n\n"+
		"Graphic frames selected: "+N_F+"\n"+
		"Images placed: "+N_PLACED+"\n"+
		"Fitting option: "+FIT_TEXT+"\n"+
		"Center images after placement: " + CENTER_TEXT+"\n\n"+
		S_SKIP+
		S_ERR+
		S_QBU
	);
	return;
};// end REPORT
//
// функция восстановления первоначального вида окна программы
function RESTORE_VIEW() 
{
	app.activeWindow.activeSpread = AS;
	BEGIN_WINDOW.zoom(ZoomOptions.fitSpread);
	return;
};// end RESTORE_VIEW
//
// подпрограмма поиска графики в массиве
function FIND_FRAMES ( the_obj )
{
	function IS_FRAME( F )
	{
		var the_name = F.constructor.name;
		if( the_name == "Rectangle" || the_name == "Oval" || the_name == "Polygon" ) return true;
		return false;
	};// end IS_FRAME
	//
	if( IS_FRAME( the_obj ) )
	{
		FRAMES_IN_SEL.push(  the_obj );
		return;
	};// if
	for( var j=0; j < the_obj.allPageItems.length; j++ ) FIND_FRAMES( the_obj.allPageItems[j] );
	return;
};// end FIND_FRAMES
//
// подпрограмма поиска графики в выделении
function FIND_FRAMES_SEL()
{
	if( app.documents.length == 0 )
	{
		alert("There are no open documents!");
		exit();
	};// if
	if(File.fs == "Windows") WFS = true; // определяем файловую систему
	AD = app.activeDocument; // акт. док-т
	var D_NAME_LEN = 12; if( WFS ) D_NAME_LEN = 20;
	D_NAME = SHORT_NAME(AD.name, D_NAME_LEN ); // имя акт. докт-та
	NS = app.activeDocument.spreads.length; // кол-во разворотов в док-те
	NMS = app.activeDocument.masterSpreads.length; // кол-во мастеров в док-те
	AS = app.activeWindow.activeSpread; // ссылка на акт. разворот		
	BEGIN_WINDOW = app.activeWindow; // начальное окно (для восстановления)
	the_sel = AD.selection;
	if( the_sel.length == 0 )
	{
		alert("There are no selected objects!");
		exit();
	};// if
	if(  the_sel[0].constructor.name == "Guide" )
	{
		alert("Guides are selected! Can not process this!");
		exit();
	};// if
	for( var i =0; i < the_sel.length; i++ )
	{
		FIND_FRAMES( the_sel[i] );
	};// for
	N_F = FRAMES_IN_SEL.length;
	if( N_F == 0 )
	{
		alert("There are no graphic frames in the selection!")
		exit();
	};// if
	return;
};// end FIND_FRAMES_SEL
//
function SHORT_NAME(txt, N) 
{
	if ( txt.length > N ) txt = txt.substr(0, N) + "...";
	return txt;
};// end SHORT_NAME
//
// подпрограмма получения имени из пути
function GET_NAME_FROM_PATH( P )
{
	var P_LEN = P.length;
	var NAME = "";
	for( var i = P_LEN -1; i >=0; i-- )
	{
		var C = P[i];
		if( C == "\\" || C == "/") break;
		NAME = C + NAME;
	};// for i
	return NAME;
};// end GET_NAME_FROM_PATH
//
// подпрограмма получения расширения файла и имени без расширения
function GET_EXT( N )
{
	// расширение на выходе
	var EXT = "";
	// только имя без расширения на выходе
	var N_ONLY = "";
	var STOP_EXT = false;
	// цикл по символам начиная с последнего
	for( var i = N.length-1; i >= 0; i-- )
	{
		var N_i = N[i];
		if( !STOP_EXT )
		{
			EXT = N_i + EXT;
			if( N_i == "." ) STOP_EXT = true;
			continue;
		};// if
	};// for
	return EXT;	
};// end GET_EXT
//
// подпрограмма проверки типа выбранного файла по расширению
function EXT_OK( name )
{
	// список подходящих расширений для файлов изображений
	var EXT_LIST = 
	[
		".psd",
		".pdf",
		".indd",
		".tif",
		".gif",
		".jpg",
		".bmp",
		".eps",
		".ai",
		".dcs",
		".pict",
		".wmf",
		".pcx",
		".png",
		".sct"
	];
	// получаем расширение из имени
	var the_ext = GET_EXT( name );
	the_ext = the_ext.toLowerCase();
	for( var i=0; i < EXT_LIST.length; i++ )
	{
		if( the_ext == EXT_LIST[i] ) return true;
	};// for
	return false;
};// end EXT_OK
//
// подпрограмма завершения работы скрипта
function the_exit()
{
	REPORT();
	DESELECT_ALL();
	RESTORE_VIEW();
	exit();
};// end the_exit